﻿REM  - Picaxe 08M2
' REMINDER             2021.09.02
' Hlídá nakapání. Pokud se zvedne lahvička a nepoloží se včas, vydá 
' varovný tón. Pokud se lahvička nezvedne a zhasne se vydá varovný tón.
' Pokud se nakape pak po vrácení vydá tón a při zhasnutí už nehraje.
' Pokud se po nakapání během hodiny znova zvedne lahvička vydá varování.
' Hlídá napětí baterie.

' Pins
symbol napaj=pin0	 ;zapinani napajeni pro mereni Ucc a fotoodporu
symbol Ucc=  pin1	 ; Ucc je deleno 2
symbol piezo=pin2  ; tune je na PIN2
symbol kontakt=pin3; kontakt kapání
symbol foto= pin4  ; fotoodpor

adcconfig %011
fvrsetup fvr2048	 ; referencni napeti  2,048 V 
			 ; nutno volat po každém použití
' Variables
symbol bat=w1	 ; hodnota napeti baterie
symbol osv=w2	 ; intenzita osvetleni fotoodporu
symbol osvold=w3   ; stara hodnota osvetleni
symbol osvnew=w4   ; nova hodnota osvetlene
symbol osvdif=w11	 ; rozdíl osvětlení
symbol n=w9        ; pocitadlo cyklu cekani
symbol k=b12 	 ; nakapáno
symbol p=b14	 ; semafor pípnutí
symbol i=b16	 ; debug ukazatel
symbol zha=b10	 ; zhaslo se
symbol stav=b20	 ; stav
n=0
k=0
p=0
stav=0
DISABLEBOD		 ; disable hlídání poklesu napětí (spotřeba)
'****************************************************//*********
start:
; pause 300	;	pro oživení odremuj
; tune 0, 4, ($42); tune 0, 4, ($C0,$40,$42,$44,$45,$C7,$C4
; debug
; sleep 1
on stav gosub stav0, stav1, stav2, stav3, stav4, stav5, stav6, stav7, stav8, stav9, stav10
goto start
'***************************************************************
stav0:
sleep 1
gosub baterie	; kontrola napětí baterie
sleep 1
gosub pip	      ; signal ze je zapnuto
low 0			; vypnuto napájení měření
stav=1
return
stav1:
low 0			; vypnuto napájení měření
sleep 32570		; 32570 ; x2,1 sec (19 hodin = 32570 )
   			; probuzen po 19-ti hodinách
k=0		      ; ještě se nakapalo
stav=2
return
stav2:
high 0 fvrsetup fvr2048  pause 200 ; zapnuto napájení foto
readadc10 4,osv	; cte se fotoodpor
osvold=osv		; stara a také -
osvnew=osv        ; - nová hodnota nastavena
stav=3
return
stav3:
n=0			; čítač cyklů
; p=1			; semafor pípnutí 1= nepípat
stav=4
return
stav4:	
gosub svetlo
if zha=1 then
	stav=5	; zhaslo se 
else  stav=6 	; nezhaslo se
	endif 
return
stav5:		; zhaslo se
gosub svetlo
if k=0 then gosub nakap:    ; hraje se melodie
gosub baterie		    ; kontrola baterie	
stav=6
return
stav6:
n=n+1 sleep 1
if zha=0 then gosub svetlo
if kontakt=0 and n>10 then 
	n=0
	stav=4 		; dlouhu se nezvedlo  22 sec
else 	stav=6 endif	; znova test kontaktu
if kontakt=1 then 	; zvednuto
	n=0 
	stav=7 endif
if zha=1 then 
	stav=5 endif
return
stav7:		
n=n+1 sleep 1
k=1			; nakapáno
if kontakt=1 and n>10 then gosub varovani ;lahvička nevrácena včas
if kontakt=1 then 
	stav=7 endif 
if kontakt=0 then 
	stav=8 endif
return
stav8:			
n=0
gosub pip:
stav=9
return
stav9:
if kontakt=1 then gosub varovani  ;lahvička nevrácena včas
stav=10
return
stav10:	
n=n+1  sleep 1
if n>1714 then 	; hodina
	stav=1 else	
	stav=9 endif
return 




'////////////////////////////////////////////////////////////////////
svetlo:
zha=0			; nuluje se příznak zhasnutí
osvold=osv		; uloží se staré osvětlení
high 0 fvrsetup fvr2048 pause 500
readadc10 4,osv   ; cte se fotoodpor		
osvnew=osv		; uloží se nové osvětlení 
; osvdif=osvold - osvnew ;rozdíl starého a nového světlení
if osvnew<300 and osvold>900 then
	zha=1 endif
return
nakap:
tune 0, 4, ($C0,$40,$42,$44,$45,$C7,$C4,$C7,$47,$42,$45,$42,$45,$84,$C0,$40,$42,$44,$45,$C7,$C4,$47,$47,$46,$47,$49,$47,$49,$4B,$90) 
n=0   		; nuluje čítač, autor melodií Vladimír Levický (děkuji)
return 
varovani:
tune 0, 4, ($E2,$6C,$E4,$4C,$A0,$6C,$23)  ;varovný tón
return
pip:		
tune 0, 3, ($4A,$4B,$50,$12)	; pípnutí, když se vrátí lahvička  
return
baterie:
 high 0 pause 1000 fvrsetup fvr2048
 readadc10 1,bat		; kontrola baterie
if bat<850 then tune 0, 4, ($15,$14,$D2,$08,$04,$C2,$A8,$A4,$A1,$21) 
endif   ; nutno připojit nabiječku Ucc < 3,6V ;
'        (3,7V=913, 3,6V=886, 3,5V=863, 3,43V=846)
if bat<840 then 
	end  endif  	; konec	
if bat<846 then 		; už není energie v baterii 
	sleep 10	
	goto baterie 	; dokola se varuje
	endif
return	

